/*
 *   zahl_einlesen_fscanf
 *   it's a standalone program, simple do gcc -o zahl_einlesen_fscanf zahl_einlesen_fscanf.c
 *
 *  read a file with numbers at each line (see accompanying number files) with
 *  the fscanf method.
 *  The goal is to investigate the impact of setting different LC_NUMERIC values
 *
 *  2014, Harald Nikolisin
 */

#include <stdio.h>
#include <stdlib.h>
#include <locale.h>
#include <stdbool.h>

#define MAX_ZEILLAENG 200

int main(int argc,char *argv[]){
  setlocale(LC_NUMERIC,"");
  FILE *fz;
  char zeile[MAX_ZEILLAENG];

  if(argc!=2){
    printf("usage: %s FILENAME\n",argv[0]);
    exit(1);
  }

  if((fz=fopen(argv[1],"r"))==NULL){
    printf("Kann Datei '%s' nicht oeffnen\n",argv[1]);
    exit(2);
  }

  int ii = 20; // maximum number of lines (prevent endless loop)
  while(true){
    float f = -1.f;
    int result = fscanf(fz,"%'f",&f);
    if(feof(fz)||ferror(fz)||ii==0) break;
    if(result<1){
      printf("Die Zeile konnte nicht in eine Zahl konvertiert werden\n");
      fscanf(fz,"%*[^\n]\n");  // read and discard rest of line
    }else{
      printf("Die Zahl ist: %'f\n",f);
      fscanf(fz,"%*[^\n]\n");
    }
    ii--;
  }

  if(ferror(fz)){
    printf("Fehler beim lesen aus Datei '%s'\n",argv[1]);
    exit(3);
  }

  fclose(fz);
  return 0;
}
