/*
 *   zahl_einlesen_strtof
 *   it's a standalone program, simple do gcc -o zahl_einlesen_strtof zahl_einlesen_strtof.c
 *
 *  read a file with numbers at each line (see accompanying number files) with
 *  the fgets and strtof methods.
 *  The goal is to investigate the impact of setting different LC_NUMERIC values
 *
 *  2014, Harald Nikolisin
 */

#include <stdio.h>
#include <stdlib.h>
#include <locale.h>

#define MAX_ZEILLAENG 200

int main(int argc,char *argv[]){
  setlocale(LC_NUMERIC,"");
  FILE *fz;
  char zeile[MAX_ZEILLAENG];

  if(argc!=2){
    printf("usage: %s FILENAME\n",argv[0]);
    exit(1);
  }

  if((fz=fopen(argv[1],"r"))==NULL){
    printf("Kann Datei '%s' nicht oeffnen\n",argv[1]);
    exit(2);
  }
  
  while(fgets(zeile,MAX_ZEILLAENG,fz)!=NULL){
    char* test;
    float f = strtof(zeile,&test);
    // does not matter if thousands separator (') was acquired or not
    printf("Die Zahl ist: %f oder %'f\n",f,f);
  }

  if(ferror(fz)){
    printf("Fehler beim lesen aus Datei '%s'\n",argv[1]);
    exit(3);
  }

  fclose(fz);
  return 0;
}
